"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var prettier = require("prettier");
var tslint = require("tslint");
var report_differences_1 = require("./utils/report-differences");
// tslint:disable:max-classes-per-file no-use-before-declare
var Rule = (function (_super) {
    tslib_1.__extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (source_file) {
        var _a = this.ruleArguments[0], raw_options = _a === void 0 ? {} : _a;
        var options = tslib_1.__assign({ parser: 'typescript' }, raw_options);
        return this.applyWithWalker(new Walker(source_file, this.ruleName, options));
    };
    return Rule;
}(tslint.Rules.AbstractRule));
exports.Rule = Rule;
var Walker = (function (_super) {
    tslib_1.__extends(Walker, _super);
    function Walker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Walker.prototype.walk = function (source_file) {
        var source = source_file.getFullText();
        var formatted = prettier.format(source, this.options);
        if (source !== formatted) {
            report_differences_1.report_differences(this, formatted);
        }
    };
    return Walker;
}(tslint.AbstractWalker));
